<!--
Copyright 2018 Google LLC

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    https://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
-->
<!doctype html>
<html lang="en-us">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-57791760-2"></script>
<script>
  window.dataLayer = window.dataLayer || [];
    function gtag(){dataLayer.push(arguments);}
      gtag('js', new Date());

        gtag('config', 'UA-57791760-2');
        </script>

   
    <title>GALOGEN</title>
    <style type = "text/css">
      body {
        background: #efefef;
        max-width: 50em;
        margin:0 auto;
        margin-top: 10pt;
        margin-bottom: 10pt;
        font-family: monospace;
        line-height: 2.0em;
      }
      #main {
        width: 100%;
        background: bisque;
        margin-left:auto;
        margin-right:auto;
        border:1px solid #101010;
        display:block;
        padding: 0px;
      }
      #header {
        padding-top: 5pt;
        padding-bottom: 5pt;
        background: #101010;
        color: #efefef;
        font-size: 20pt;
        text-align: center;
        width:100%;
        display: inline-block;
     }
      #form {padding: 10pt}
      select {
        font-family: monospace;
        width: 100pt;
      }
      #output {
        margin: 10pt;
        padding: 5pt;
        border: 1px dotted #101010;
        visibility: hidden;
      }
      .outfile {
        width: 100%;
        height: 20em;
      }
      #result {
        margin: 10pt;
        padding: 5pt;
      }
      .textinput {
        font-family: monospace;
        width: 200pt;
      }
    </style>
  <script type = "text/javascript">
  function onGenerate() {
    var files_container = document.getElementById("files_container");
    files_container.innerHTML = "";
    var args = [];
    args.push("dummy")
    args.push("third_party/gl.xml");
    args.push("--api");
    args.push(document.getElementById("api").value);
    args.push("--ver");
    args.push(document.getElementById("ver").value);
    args.push("--profile")
    args.push(document.getElementById("profile").value);
    var extslist = document.getElementById("exts").value;
    if (extslist.length > 0) {
      args.push("--exts");
      args.push(extslist);
    }
    var argslist = Module._malloc(args.length * 4);
    var argbufs = [];
    for (var i = 0; i < args.length; ++i) {
      var arg = args[i];
      var argbuf = Module._malloc(arg.length + 1);
      Module.stringToUTF8(arg, argbuf, arg.length + 1);
      argbufs.push(argbuf);
      Module.setValue(argslist + 4 * i, argbuf, "i8*");
    }
    Module.ccall('jsmain', 'number', ['number', 'number'], [args.length, argslist]);
    for (var i = 0; i < argbufs.length; ++i) {
      Module._free(argbufs[i]);
    }
    Module._free(argslist);
    var result_html = "<div id = 'result'><hr/><h3>Generated files</h3>";
    var fsrootnode = FS.lookupPath("/").node;
    for (child_name in fsrootnode.contents) {
      var child = fsrootnode.contents[child_name];
      if (!child.isFolder && child.name != "gl.xml") {
        result_html += "<b>" + child.name + ":</b><br/>";
        result_html += "<textarea class = 'outfile'>";
        result_html += FS.readFile(child_name, {encoding: 'utf8'});
        result_html += "</textarea>"
        FS.unlink(child.name);
      }
    }
    result_html += "</div>";
    files_container.innerHTML = result_html;
  }

  function onApiSelected(api) {
    var option = function(ver) { return "<option value =\"" + ver + "\">" + ver + "</option>"; };
    var api_vers = "";
    // TODO: get this info from XML
    switch(api) {
    case "gl":
      api_vers =
        option("1.0") +
        option("1.1") +
        option("1.2") +
        option("1.3") +
        option("1.4") +
        option("1.5") +
        option("2.0") +
        option("2.1") +
        option("3.0") +
        option("3.1") +
        option("3.2") +
        option("3.2") +
        option("3.3") +        
        option("4.0") +
        option("4.1") +
        option("4.2") +
        option("4.3") +
        option("4.4") +
        option("4.5") +
        option("4.6");
      break;
    case "gles1":
      api_vers = option("1.0");
      break;
    case "gles2":
      api_vers = option("2.0") +
                 option("3.0") +
                 option("3.1") +
                 option("3.2");
      break;
    case "glsc2":
      api_vers = option("2.0");
    }
    document.getElementById("ver").innerHTML = api_vers;
  }
  </script>
  </head>
  <body onload = "onApiSelected('gl')">
   <div id = "main">
   <div id = "header">GALOGEN</div>
   <div id = "form">
    <table>
    <tr>
      <td>API</td>
      <td>
        <select id = "api" onchange = "onApiSelected(this.value)">
          <option value = "gl">GL</option>
          <option value = "gles1">GL ES 1</option>
          <option value = "gles2">GL ES 2/3</option>
          <option value = "glsc2">GL SC 2</option>
       </select>
      </td>
    </tr>
    <tr>
    <td>Version</td>
    <td><select id = "ver"></select></td>
    </tr>
    <tr>
      <td>Profile</td>
      <td>
        <select id = "profile">
          <option value = "core">core</option>
          <option value = "compatibility">compatibility</option>
        </select>
      </td>
    </tr>
    <tr>
    <td>Extensions</td><td><input id = "exts" type = "text" class="textinput"/></td>
    </tr>
    </table>
    <input type = "button" value="Generate" onclick = "onGenerate()"/><br>
    </div>
    <pre id = "output"></pre>
    <div id = "files_container"></div>
    <script type='text/javascript'>
      var Module = {
        preRun: [],
        postRun: [],
        print: (function() {
          return function(text) {
            var output_elem = document.getElementById("output");
            output_elem.style.visibility = "visible";
            if (arguments.length > 1) {
              text = Array.prototype.slice.call(arguments).join(' ');
            }
            if (output_elem) {
              output_elem.innerHTML += "<span>" + text + "</span>\n";
            }
          };
        })(),
        printErr: (function() {
          return function(text) {
            var output_elem = document.getElementById("output");
            output_elem.style.visibility = "visible";
            if (arguments.length > 1) {
              text = Array.prototype.slice.call(arguments).join(' ');
            }
            if (output_elem) {
              output_elem.innerHTML += "<span style='color:red'>" + text + "</span>\n";
            }
          };
        })(),
        canvas: null,
        setStatus: function(text) {},
        totalDependencies: 0,
        monitorRunDependencies: function(left) {
          this.totalDependencies = Math.max(this.totalDependencies, left);
          Module.setStatus(left ? 'Preparing... (' + (this.totalDependencies-left) + '/' + this.totalDependencies + ')' : 'All downloads complete.');
        }
      };
      window.onerror = function(event) {
        Module.setStatus('Exception thrown, see JavaScript console');
        Module.setStatus = function(text) {
          if (text) Module.printErr('[post-exception status] ' + text);
        };
      };
    </script>
    <script>
var ASSERTIONS = 0;
// Prefix of data URIs emitted by SINGLE_FILE and related options.
var dataURIPrefix = 'data:application/octet-stream;base64,';

// Indicates whether filename is a base64 data URI.
function isDataURI(filename) {
  return String.prototype.startsWith ?
      filename.startsWith(dataURIPrefix) :
      filename.indexOf(dataURIPrefix) === 0;
}

// Copied from https://github.com/strophe/strophejs/blob/e06d027/src/polyfills.js#L149

// This code was written by Tyler Akins and has been placed in the
// public domain.  It would be nice if you left this header intact.
// Base64 code from Tyler Akins -- http://rumkin.com

/**
 * Decodes a base64 string.
 * @param {String} input The string to decode.
 */
var decodeBase64 = typeof atob === 'function' ? atob : function (input) {
  var keyStr = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';

  var output = '';
  var chr1, chr2, chr3;
  var enc1, enc2, enc3, enc4;
  var i = 0;
  // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
  input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');
  do {
    enc1 = keyStr.indexOf(input.charAt(i++));
    enc2 = keyStr.indexOf(input.charAt(i++));
    enc3 = keyStr.indexOf(input.charAt(i++));
    enc4 = keyStr.indexOf(input.charAt(i++));

    chr1 = (enc1 << 2) | (enc2 >> 4);
    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
    chr3 = ((enc3 & 3) << 6) | enc4;

    output = output + String.fromCharCode(chr1);

    if (enc3 !== 64) {
      output = output + String.fromCharCode(chr2);
    }
    if (enc4 !== 64) {
      output = output + String.fromCharCode(chr3);
    }
  } while (i < input.length);
  return output;
};

// Converts a string of base64 into a byte array.
// Throws error on invalid input.
function intArrayFromBase64(s) {
  if (typeof ENVIRONMENT_IS_NODE === 'boolean' && ENVIRONMENT_IS_NODE) {
    var buf;
    try {
      buf = Buffer.from(s, 'base64');
    } catch (_) {
      buf = new Buffer(s, 'base64');
    }
    return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength);
  }

  try {
    var decoded = decodeBase64(s);
    var bytes = new Uint8Array(decoded.length);
    for (var i = 0 ; i < decoded.length ; ++i) {
      bytes[i] = decoded.charCodeAt(i);
    }
    return bytes;
  } catch (_) {
    throw new Error('Converting base64 string to bytes failed.');
  }
}

// If filename is a base64 data URI, parses and returns data (Buffer on node,
// Uint8Array otherwise). If filename is not a base64 data URI, returns undefined.
function tryParseAsDataURI(filename) {
  if (!isDataURI(filename)) {
    return;
  }

  return intArrayFromBase64(filename.slice(dataURIPrefix.length));
}
/** @type {function(string, boolean=, number=)} */
function intArrayFromString(stringy, dontAddNull, length) {
  var len = length > 0 ? length : lengthBytesUTF8(stringy)+1;
  var u8array = new Array(len);
  var numBytesWritten = stringToUTF8Array(stringy, u8array, 0, u8array.length);
  if (dontAddNull) u8array.length = numBytesWritten;
  return u8array;
}

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      if (ASSERTIONS) {
        assert(false, 'Character code ' + chr + ' (' + String.fromCharCode(chr) + ')  at offset ' + i + ' not in 0x00-0xFF.');
      }
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}

          var memoryInitializer = 'galogen.html.mem';
          if (typeof Module['locateFile'] === 'function') {
            memoryInitializer = Module['locateFile'](memoryInitializer);
          } else if (Module['memoryInitializerPrefixURL']) {
            memoryInitializer = Module['memoryInitializerPrefixURL'] + memoryInitializer;
          }
          Module['memoryInitializerRequestURL'] = memoryInitializer;
          var meminitXHR = Module['memoryInitializerRequest'] = new XMLHttpRequest();
          meminitXHR.open('GET', memoryInitializer, true);
          meminitXHR.responseType = 'arraybuffer';
          meminitXHR.send(null);

          var script = document.createElement('script');
          script.src = "galogen.js";
          document.body.appendChild(script);

</script>
  </body>
</html>
